diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_win32.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_win32.c
--- src/netsys/netsys_c_win32.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_win32.c	2026-05-29 06:31:44
@@ -57,7 +57,7 @@
     };
     return Val_unit;
 #else
-    invalid_argument("netsys_fill_random");
+    caml_invalid_argument("netsys_fill_random");
 #endif
 }
 
@@ -76,7 +76,7 @@
     };
     return caml_copy_string(buffer);
 #else
-    invalid_argument("netsys_get_full_path_name");
+    caml_invalid_argument("netsys_get_full_path_name");
 #endif
 }
 
@@ -94,7 +94,7 @@
     };
     return caml_copy_string(buffer);
 #else
-    invalid_argument("netsys_get_long_path_name");
+    caml_invalid_argument("netsys_get_long_path_name");
 #endif
 }
 
@@ -112,7 +112,7 @@
     }
     return Val_unit;
 #else
-    invalid_argument("netsys_modify_close_on_exec");
+    caml_invalid_argument("netsys_modify_close_on_exec");
 #endif
 }
 
@@ -131,7 +131,7 @@
 	    Handle_val(fd), r ? "true" : "false");
     return Val_bool(r);
 #else
-    invalid_argument("netsys_test_close_on_exec");
+    caml_invalid_argument("netsys_test_close_on_exec");
 #endif
 }
 
@@ -145,7 +145,7 @@
     else
 	return Val_bool(fd1 == Int_val(crt_fd));
 #else
-    invalid_argument("netsys_is_crt_fd");
+    caml_invalid_argument("netsys_is_crt_fd");
 #endif
 }
 
@@ -224,7 +224,7 @@
 
     return alloc_event(e);
 #else
-    invalid_argument("netsys_create_event");
+    caml_invalid_argument("netsys_create_event");
 #endif
 }
 
@@ -246,7 +246,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("netsys_close_event");
+    caml_invalid_argument("netsys_close_event");
 #endif
 }
 
@@ -259,7 +259,7 @@
     e->auto_close = Bool_val(flag);
     return Val_unit;
 #else
-    invalid_argument("netsys_set_auto_close_event_proxy");
+    caml_invalid_argument("netsys_set_auto_close_event_proxy");
 #endif
 }
 
@@ -276,7 +276,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("netsys_set_event");
+    caml_invalid_argument("netsys_set_event");
 #endif
 }
 
@@ -292,7 +292,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("netsys_reset_event");
+    caml_invalid_argument("netsys_reset_event");
 #endif
 }
 
@@ -312,7 +312,7 @@
 
     return Val_bool(n == WAIT_OBJECT_0);
 #else
-    invalid_argument("netsys_test_event");
+    caml_invalid_argument("netsys_test_event");
 #endif
 }
 
@@ -331,10 +331,10 @@
     };
 
     e = event_val(ev);
-    enter_blocking_section();
+    caml_enter_blocking_section();
     n = WaitForSingleObject(e->ev, wtmo);
     err = GetLastError();
-    leave_blocking_section();
+    caml_leave_blocking_section();
     if (n == WAIT_FAILED) {
 	win32_maperr(err);
 	uerror("netsys_event_wait/WaitForSingleObject", Nothing);
@@ -342,7 +342,7 @@
 
     return Val_bool(n == WAIT_OBJECT_0);
 #else
-    invalid_argument("netsys_event_wait");
+    caml_invalid_argument("netsys_event_wait");
 #endif
 }
 
@@ -353,7 +353,7 @@
     e = event_val(ev);
     return netsysw32_win_alloc_handle(e->ev_proxy);
 #else
-    invalid_argument("netsys_event_descr");
+    caml_invalid_argument("netsys_event_descr");
 #endif
 }
 
@@ -383,7 +383,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("netsys_wsa_event_select");
+    caml_invalid_argument("netsys_wsa_event_select");
 #endif
 }
 
@@ -391,7 +391,7 @@
 #ifdef _WIN32
     return Val_int(WSA_MAXIMUM_WAIT_EVENTS);
 #else
-    invalid_argument("netsys_wsa_maximum_wait_events");
+    caml_invalid_argument("netsys_wsa_maximum_wait_events");
 #endif
 }
 
@@ -428,9 +428,9 @@
 	    tmo = tmo0;
 	else
 	    tmo = INFINITE;
-	enter_blocking_section();
+	caml_enter_blocking_section();
 	r = SleepEx(tmo, 1);
-	leave_blocking_section();
+	caml_leave_blocking_section();
 	
 	if (r == WAIT_IO_COMPLETION) {
 	    win32_maperr(EINTR);
@@ -445,10 +445,10 @@
 	else
 	    tmo = INFINITE;
 	dprintf("WSAWaitForMultipleEvents start tmo=%u\n", tmo);
-	enter_blocking_section();
+	caml_enter_blocking_section();
 	r = WSAWaitForMultipleEvents(n, earray, 0, tmo, 1);
 	err = WSAGetLastError();
-	leave_blocking_section();
+	caml_leave_blocking_section();
 	dprintf("WSAWaitForMultipleEvents end code=%u\n", r);
     
 	if (r == WSA_WAIT_FAILED) {
@@ -476,9 +476,9 @@
 	}
     }
     
-    invalid_argument("netsys_wsa_wait_for_multiple_events: bad return value from Win32");
+    caml_invalid_argument("netsys_wsa_wait_for_multiple_events: bad return value from Win32");
 #else
-    invalid_argument("netsys_wsa_wait_for_multiple_events");
+    caml_invalid_argument("netsys_wsa_wait_for_multiple_events");
 #endif
 }
 
@@ -538,7 +538,7 @@
 
     return Val_int(r);
 #else
-    invalid_argument("netsys_wsa_enum_network_events");
+    caml_invalid_argument("netsys_wsa_enum_network_events");
 #endif
 }
 
@@ -626,20 +626,20 @@
 	uerror("alloc_pipe_helper/CreateEvent", Nothing);
     };
 
-    rd_ovrlp = stat_alloc(sizeof(OVERLAPPED));
+    rd_ovrlp = caml_stat_alloc(sizeof(OVERLAPPED));
     ZeroMemory(rd_ovrlp, sizeof(OVERLAPPED));
     rd_ovrlp->hEvent = rd_ev;
 
-    wr_ovrlp = stat_alloc(sizeof(OVERLAPPED));
+    wr_ovrlp = caml_stat_alloc(sizeof(OVERLAPPED));
     ZeroMemory(wr_ovrlp, sizeof(OVERLAPPED));
     wr_ovrlp->hEvent = wr_ev;
 
-    cn_ovrlp = stat_alloc(sizeof(OVERLAPPED));
+    cn_ovrlp = caml_stat_alloc(sizeof(OVERLAPPED));
     ZeroMemory(cn_ovrlp, sizeof(OVERLAPPED));
     if (cn_ev != INVALID_HANDLE_VALUE)
 	cn_ovrlp->hEvent = cn_ev;
 
-    ph = stat_alloc(sizeof(struct pipe_helper));
+    ph = caml_stat_alloc(sizeof(struct pipe_helper));
     ph->pipe_handle = h;
     ph->pipe_is_open = 1;
     ph->pipe_is_server = 0;
@@ -680,10 +680,10 @@
     if (ph->pipe_cn_ev != INVALID_HANDLE_VALUE)
 	CloseHandle(ph->pipe_cn_ev);
     /* do nothing about pipe_signal */
-    stat_free(ph->pipe_rd_ovrlp);
-    stat_free(ph->pipe_wr_ovrlp);
-    stat_free(ph->pipe_cn_ovrlp);
-    stat_free(ph);
+    caml_stat_free(ph->pipe_rd_ovrlp);
+    caml_stat_free(ph->pipe_wr_ovrlp);
+    caml_stat_free(ph->pipe_cn_ovrlp);
+    caml_stat_free(ph);
 }
 
 
@@ -1032,7 +1032,7 @@
 	    ph->pipe_handle);
     return r;
 #else
-    invalid_argument("netsys_create_local_named_pipe");
+    caml_invalid_argument("netsys_create_local_named_pipe");
 #endif
 }
 
@@ -1130,7 +1130,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("netsys_pipe_listen");
+    caml_invalid_argument("netsys_pipe_listen");
 #endif
 }
 
@@ -1175,13 +1175,13 @@
     /* Check whether the overlapped ops are done: */
     check_for_pending_operations(ph);
     if (ph->pipe_cn_ovrlp_started) {
-	failwith("netsys_pipe_unlisten: cannot stop pending ConnectNamedPipe");
+	caml_failwith("netsys_pipe_unlisten: cannot stop pending ConnectNamedPipe");
     };
     if (ph->pipe_rd_ovrlp_started) {
-	failwith("netsys_pipe_unlisten: cannot stop pending ReadFile");
+	caml_failwith("netsys_pipe_unlisten: cannot stop pending ReadFile");
     };
     if (ph->pipe_wr_ovrlp_started) {
-	failwith("netsys_pipe_unlisten: cannot stop pending WriteFile");
+	caml_failwith("netsys_pipe_unlisten: cannot stop pending WriteFile");
     };
 
     dprintf("PIPE deafen %u successful\n",
@@ -1202,7 +1202,7 @@
     return Val_unit;
 
 #else
-    invalid_argument("netsys_pipe_unlisten");
+    caml_invalid_argument("netsys_pipe_unlisten");
 #endif
 }
 
@@ -1272,7 +1272,7 @@
     return r;
 
 #else
-    invalid_argument("netsys_pipe_connect");
+    caml_invalid_argument("netsys_pipe_connect");
 #endif
 }
 
@@ -1333,7 +1333,7 @@
 
     return Val_int(l);
 #else
-    invalid_argument("netsys_pipe_read");
+    caml_invalid_argument("netsys_pipe_read");
 #endif
 }
 
@@ -1400,7 +1400,7 @@
 
     return Val_int(l);
 #else
-    invalid_argument("netsys_pipe_write");
+    caml_invalid_argument("netsys_pipe_write");
 #endif
 }
 
@@ -1438,7 +1438,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("netsys_pipe_shutdown");
+    caml_invalid_argument("netsys_pipe_shutdown");
 #endif
 }
 
@@ -1453,7 +1453,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("netsys_pipe_free");
+    caml_invalid_argument("netsys_pipe_free");
 #endif
 }
 
@@ -1469,7 +1469,7 @@
 
     return Val_int(ph->pipe_conn_state);
 #else
-    invalid_argument("netsys_pipe_conn_state");
+    caml_invalid_argument("netsys_pipe_conn_state");
 #endif
 }
 
@@ -1487,7 +1487,7 @@
 
     return alloc_event(ph->pipe_rd_ev);
 #else
-    invalid_argument("netsys_pipe_rd_event");
+    caml_invalid_argument("netsys_pipe_rd_event");
 #endif
 }
 
@@ -1505,7 +1505,7 @@
 
     return alloc_event(ph->pipe_wr_ev);
 #else
-    invalid_argument("netsys_pipe_wr_event");
+    caml_invalid_argument("netsys_pipe_wr_event");
 #endif
 }
 
@@ -1518,7 +1518,7 @@
 
     return netsysw32_win_alloc_handle(ph->pipe_descr);
 #else
-    invalid_argument("netsys_pipe_descr");
+    caml_invalid_argument("netsys_pipe_descr");
 #endif
 }
 
@@ -1530,7 +1530,7 @@
     ph->pipe_descr_auto_close = Bool_val(flag);
     return Val_unit;
 #else
-    invalid_argument("netsys_set_auto_close_pipe_proxy");
+    caml_invalid_argument("netsys_set_auto_close_pipe_proxy");
 #endif
 }
 
@@ -1546,7 +1546,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("netsys_pipe_signal");
+    caml_invalid_argument("netsys_pipe_signal");
 #endif
 }
 
@@ -1658,7 +1658,7 @@
 	      pass_std_handles = 1;
 	      break;
 	  default:
-	      invalid_argument("netsys_create_process [1]");
+	      caml_invalid_argument("netsys_create_process [1]");
 	  }
       }
       else {
@@ -1687,7 +1687,7 @@
 	      pg_flags = 0;
 	      break;
 	  default:
-	      invalid_argument("netsys_create_process [2]");
+	      caml_invalid_argument("netsys_create_process [2]");
 	  }
       };
       opts_hd = Field(opts_hd,1);
@@ -1716,7 +1716,7 @@
 	  pi.hProcess, pi.dwProcessId);
   return alloc_process(pi.hProcess, pi.dwProcessId);
 #else
-    invalid_argument("netsys_create_process");
+    caml_invalid_argument("netsys_create_process");
 #endif
 }
 
@@ -1751,7 +1751,7 @@
     if (pathlen < 256) pathlen = 256;
     cont = 1;
     while (cont) {
-	fullname = stat_alloc(pathlen);
+	fullname = caml_stat_alloc(pathlen);
 	code = SearchPath(path,
 			  file,
 			  ext,
@@ -1760,7 +1760,7 @@
 			  NULL);
 	cont = (code >= pathlen);
 	if (cont) {
-	    stat_free(fullname);
+	    caml_stat_free(fullname);
 	    pathlen = code+1;  /* space for NULL byte! */
 	}
     }
@@ -1768,16 +1768,16 @@
     caml_leave_blocking_section();
 
     if (code == 0) {
-	stat_free(fullname);
+	caml_stat_free(fullname);
 	errno = ENOENT;
 	uerror("netsys_search_path", file_v);
     };
 
     r = caml_copy_string(fullname);
-    stat_free(fullname);
+    caml_stat_free(fullname);
     return r;
 #else
-    invalid_argument("netsys_search_path");
+    caml_invalid_argument("netsys_search_path");
 #endif
 }
 
@@ -1794,7 +1794,7 @@
     }
     return Val_unit;
 #else
-    invalid_argument("netsys_terminate_process");
+    caml_invalid_argument("netsys_terminate_process");
 #endif
 }
 
@@ -1807,7 +1807,7 @@
     p0 = process_val(pv);
     return netsysw32_win_alloc_handle(p0->proc_proxy);
 #else
-    invalid_argument("netsys_process_descr");
+    caml_invalid_argument("netsys_process_descr");
 #endif
 }
 
@@ -1819,7 +1819,7 @@
     p0->auto_close = Bool_val(flag);
     return Val_unit;
 #else
-    invalid_argument("netsys_set_auto_close_process_proxy");
+    caml_invalid_argument("netsys_set_auto_close_process_proxy");
 #endif
 }
 
@@ -1834,7 +1834,7 @@
     };
     return Val_unit;
 #else
-    invalid_argument("netsys_close_process");
+    caml_invalid_argument("netsys_close_process");
 #endif
 }
 
@@ -1846,10 +1846,10 @@
 	CloseHandle(p0->proc);
     if (p0->auto_close)
 	CloseHandle(p0->proc_proxy);
-    stat_free(p0);
+    caml_stat_free(p0);
     return Val_unit;
 #else
-    invalid_argument("netsys_close_process");
+    caml_invalid_argument("netsys_close_process");
 #endif
 }
 
@@ -1870,7 +1870,7 @@
 	uerror("netsys_get_process_status/WaitForSingleObject", Nothing);
     };
     if (code != WAIT_OBJECT_0) {
-	invalid_argument("netsys_get_process_status [1]");
+	caml_invalid_argument("netsys_get_process_status [1]");
     };
     /* Now get the status: */
     code = GetExitCodeProcess(p0->proc, &status);
@@ -1882,7 +1882,7 @@
     return Val_int(status);
 
 #else
-    invalid_argument("netsys_get_process_status");
+    caml_invalid_argument("netsys_get_process_status");
 #endif
 }
 
@@ -1893,7 +1893,7 @@
     p0 = process_val(pv);
     return alloc_event(p0->proc);
 #else
-    invalid_argument("netsys_as_process_event");
+    caml_invalid_argument("netsys_as_process_event");
 #endif
 }
 
@@ -1915,7 +1915,7 @@
     };
     return Val_int(d);
 #else
-    invalid_argument("netsys_emulated_pid");
+    caml_invalid_argument("netsys_emulated_pid");
 #endif
 }
 
@@ -1926,7 +1926,7 @@
     p0 = process_val(pv);
     return Val_int(p0->win_pid);
 #else
-    invalid_argument("netsys_win_pid");
+    caml_invalid_argument("netsys_win_pid");
 #endif
 }
 
@@ -1935,7 +1935,7 @@
 #ifdef _WIN32
     return Val_bool(has_console());
 #else
-    invalid_argument("netsys_has_console");
+    caml_invalid_argument("netsys_has_console");
 #endif
 }
 
@@ -1950,7 +1950,7 @@
     else
 	return Val_bool(1);
 #else
-    invalid_argument("netsys_is_console");
+    caml_invalid_argument("netsys_is_console");
 #endif
 }
 
@@ -1962,7 +1962,7 @@
     }
     return Val_unit;
 #else
-    invalid_argument("netsys_alloc_console");
+    caml_invalid_argument("netsys_alloc_console");
 #endif
 }
 
@@ -2001,7 +2001,7 @@
 
     return r;
 #else
-    invalid_argument("netsys_get_console_attr");
+    caml_invalid_argument("netsys_get_console_attr");
 #endif
 }
 
@@ -2060,7 +2060,7 @@
   
     return Val_unit;
 #else
-    invalid_argument("netsys_set_console_attr");
+    caml_invalid_argument("netsys_set_console_attr");
 #endif
 }
 
@@ -2092,7 +2092,7 @@
 
     return r;
 #else
-    invalid_argument("netsys_get_console_info");
+    caml_invalid_argument("netsys_get_console_info");
 #endif
 }
 
@@ -2146,7 +2146,7 @@
 
     return r;
 #else
-    invalid_argument("netsys_get_console_mode");
+    caml_invalid_argument("netsys_get_console_mode");
 #endif
 }
 
@@ -2215,7 +2215,7 @@
     CloseHandle(conout);
     return Val_unit;
 #else
-    invalid_argument("netsys_set_console_mode");
+    caml_invalid_argument("netsys_set_console_mode");
 #endif
 }
 
@@ -2224,7 +2224,7 @@
 #ifdef _WIN32
     return Val_int(GetACP());
 #else
-    invalid_argument("netsys_getacp");
+    caml_invalid_argument("netsys_getacp");
 #endif
 }
 
@@ -2243,7 +2243,7 @@
     }
     return Val_unit;
 #else
-    invalid_argument("netsys_init_console_codepage");
+    caml_invalid_argument("netsys_init_console_codepage");
 #endif
 }
 
@@ -2338,7 +2338,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("netsys_clear_console");
+    caml_invalid_argument("netsys_clear_console");
 #endif
 }
 
@@ -2347,7 +2347,7 @@
 #ifdef _WIN32
     return caml_copy_int32(GetCurrentThreadId());
 #else
-    invalid_argument("netsys_get_current_thread_id");
+    caml_invalid_argument("netsys_get_current_thread_id");
 #endif
 }
 
@@ -2394,7 +2394,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("netsys_cancel_synchronous_io");
+    caml_invalid_argument("netsys_cancel_synchronous_io");
 #endif
 }
 
@@ -2439,7 +2439,7 @@
     for (/*nothing*/; fdlist != Val_int(0); fdlist = Field(fdlist, 1)) {
       s = Field(fdlist, 0);
       if (FD_ISSET(Socket_val(s), fdset)) {
-        value newres = alloc_small(2, 0);
+        value newres = caml_alloc_small(2, 0);
         Field(newres, 0) = s;
         Field(newres, 1) = res;
         res = newres;
@@ -2471,9 +2471,9 @@
 	&& writefds == Val_int(0)
 	&& exceptfds == Val_int(0)) {
       if ( tm > 0.0 ) {
-	enter_blocking_section();
+	caml_enter_blocking_section();
 	Sleep( (int)(tm * 1000));
-	leave_blocking_section();
+	caml_leave_blocking_section();
       }
       read_list = write_list = except_list = Val_int(0);
     } else {      
@@ -2487,10 +2487,10 @@
 	tv.tv_usec = (int) (1e6 * (tm - (int) tm));
 	tvp = &tv;
       }
-      enter_blocking_section();
+      caml_enter_blocking_section();
       if (select(FD_SETSIZE, &read, &write, &except, tvp) == -1)
         err = WSAGetLastError();
-      leave_blocking_section();
+      caml_leave_blocking_section();
       if (err) {
 	win32_maperr(err);
 	uerror("select", Nothing);
@@ -2499,7 +2499,7 @@
       write_list = fdset_to_fdlist(writefds, &write);
       except_list = fdset_to_fdlist(exceptfds, &except);
     }
-    res = alloc_small(3, 0);
+    res = caml_alloc_small(3, 0);
     Field(res, 0) = read_list;
     Field(res, 1) = write_list;
     Field(res, 2) = except_list;
@@ -2507,6 +2507,6 @@
   End_roots();
   return res;
 #else
-    invalid_argument("netsys_real_select");
+    caml_invalid_argument("netsys_real_select");
 #endif
 }
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_impl_util.ml ocamlnet-4.1.9.patched/src/netsys/netsys_impl_util.ml
--- src/netsys/netsys_impl_util.ml	2021-03-24 16:20:14
+++ src/netsys/netsys_impl_util.ml	2026-05-29 06:31:44
@@ -67,7 +67,7 @@
   let rec search l h =
     if l < h then (
       let m = (l+h) / 2 in
-      let r = Pervasives.compare x a.(m) in
+      let r = compare x a.(m) in
       if r = 0 then
 	true
       else
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_pollset_win32.ml ocamlnet-4.1.9.patched/src/netsys/netsys_pollset_win32.ml
--- src/netsys/netsys_pollset_win32.ml	2021-03-24 16:20:14
+++ src/netsys/netsys_pollset_win32.ml	2026-05-29 06:31:44
@@ -27,9 +27,9 @@
   let in_arr  = Array.of_list in_set in
   let out_arr = Array.of_list out_set in
   let pri_arr = Array.of_list pri_set in
-  Array.sort Pervasives.compare in_arr;
-  Array.sort Pervasives.compare out_arr;
-  Array.sort Pervasives.compare pri_arr;
+  Array.sort compare in_arr;
+  Array.sort compare out_arr;
+  Array.sort compare pri_arr;
   Hashtbl.fold
     (fun fd (ev,_) l ->
        let m_in = Netsys_impl_util.mem_sorted_array fd in_arr in
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_posix.ml ocamlnet-4.1.9.patched/src/netsys/netsys_posix.ml
--- src/netsys/netsys_posix.ml	2021-03-24 16:20:14
+++ src/netsys/netsys_posix.ml	2026-05-29 06:31:44
@@ -337,9 +337,9 @@
 	let a_inp = Array.of_list o_inp in
 	let a_out = Array.of_list o_out in
 	let a_pri = Array.of_list o_pri in
-	Array.sort Pervasives.compare a_inp;
-	Array.sort Pervasives.compare a_out;
-	Array.sort Pervasives.compare a_pri;
+        Array.sort compare a_inp;
+        Array.sort compare a_out;
+        Array.sort compare a_pri;
 	let n = ref 0 in
 	for j = 0 to k-1 do
 	  let c = e.(j) in
@@ -679,7 +679,7 @@
 
 module PFH = struct
   type t = post_fork_handler
-  let compare = Pervasives.compare
+  let compare = compare
 end
 
 module PFH_Set = Set.Make(PFH)
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/nettls-gnutls/META.in ocamlnet-4.1.9.patched/src/nettls-gnutls/META.in
--- src/nettls-gnutls/META.in	2021-03-24 16:20:15
+++ src/nettls-gnutls/META.in	2026-05-29 06:31:44
@@ -1,5 +1,5 @@
 description = "Ocamlnet - GnuTLS bindings"
-requires = "unix,bigarray,netsys,netstring"
+requires = "unix,netsys,netstring"
 version = "@VERSION@"
 archive(byte) = "nettls-gnutls.cma"
 archive(native) = "nettls-gnutls.cmxa"
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/nettls-gnutls/gnutls.c ocamlnet-4.1.9.patched/src/nettls-gnutls/gnutls.c
--- src/nettls-gnutls/gnutls.c	2021-03-24 16:20:15
+++ src/nettls-gnutls/gnutls.c	2026-05-29 06:31:44
@@ -111,26 +111,26 @@
 static gnutls_datum_t unwrap_str_datum(value v) {
     gnutls_datum_t d;
     d.size = caml_string_length(v);
-    d.data = stat_alloc(d.size);
+    d.data = caml_stat_alloc(d.size);
     memcpy(d.data, String_val(v), d.size);
     return d;
 }
    
 static gnutls_datum_t * unwrap_str_datum_p(value v) {
     gnutls_datum_t *d;
-    d = stat_alloc(sizeof(gnutls_datum_t));
+    d = caml_stat_alloc(sizeof(gnutls_datum_t));
     *d = unwrap_str_datum(v);
     return d;
 }
    
 static void free_str_datum(gnutls_datum_t d) {
-    if (d.data != NULL) { stat_free(d.data); d.data = NULL; };
+    if (d.data != NULL) { caml_stat_free(d.data); d.data = NULL; };
 }
 
 static void free_str_datum_p(gnutls_datum_t *d) {
     if (d != NULL) {
-        if (d->data != NULL) stat_free(d->data);
-        stat_free(d);
+        if (d->data != NULL) caml_stat_free(d->data);
+        caml_stat_free(d);
     }
 }
    
@@ -405,7 +405,7 @@
     b_session_callbacks_t cb;
 
     cb = (b_session_callbacks_t) 
-            stat_alloc(sizeof(struct b_session_callbacks_st));
+            caml_stat_alloc(sizeof(struct b_session_callbacks_st));
     cb->session = s;
     cb->pull_fun = Val_int(0);
     cb->pull_timeout_fun = Val_int(0);
@@ -458,7 +458,7 @@
     caml_remove_generational_global_root(&(cb->db_store_fun));
     caml_remove_generational_global_root(&(cb->db_remove_fun));
 
-    stat_free(cb);
+    caml_stat_free(cb);
     gnutls_deinit(s);
 }
 
@@ -484,7 +484,7 @@
     caml_modify_generational_global_root(&(cb->pull_timeout_fun), fun);
     return Val_unit;
 #else
-    invalid_argument("b_set_pull_timeout_callback");
+    caml_invalid_argument("b_set_pull_timeout_callback");
 #endif
 }
 
@@ -510,7 +510,7 @@
     caml_modify_generational_global_root(&(cb->verify_fun), fun);
     return Val_unit;
 #else
-    invalid_argument("b_set_verify_callback");
+    caml_invalid_argument("b_set_verify_callback");
 #endif
 }
 
@@ -602,7 +602,7 @@
                                    );
         break;
     default:
-        failwith("net_gnutls_credentials_set");
+        caml_failwith("net_gnutls_credentials_set");
     };
     net_gnutls_error_check(error_code);
     attach_gnutls_session_t(sess, creds);
@@ -633,7 +633,7 @@
     code = gnutls_x509_crt_list_import(certs, &n, &data, format, 
                     flags | GNUTLS_X509_CRT_LIST_IMPORT_FAIL_IF_EXCEED);
     if (code == GNUTLS_E_SHORT_MEMORY_BUFFER) {
-        certs = (gnutls_x509_crt_t *) stat_alloc(n * sizeof(void *));
+        certs = (gnutls_x509_crt_t *) caml_stat_alloc(n * sizeof(void *));
         alloc_certs = 1;
         code = gnutls_x509_crt_list_import(certs, &n, &data, format, 
                                            flags);
@@ -646,7 +646,7 @@
         };
     };
     if (alloc_certs)
-        stat_free(certs);
+        caml_stat_free(certs);
     net_gnutls_error_check(code);
     CAMLreturn(array);
 }
@@ -676,7 +676,7 @@
     code = gnutls_x509_crl_list_import(certs, &n, &data, format, 
                     flags | GNUTLS_X509_CRT_LIST_IMPORT_FAIL_IF_EXCEED);
     if (code == GNUTLS_E_SHORT_MEMORY_BUFFER) {
-        certs = (gnutls_x509_crl_t *) stat_alloc(n * sizeof(void *));
+        certs = (gnutls_x509_crl_t *) caml_stat_alloc(n * sizeof(void *));
         alloc_certs = 1;
         code = gnutls_x509_crl_list_import(certs, &n, &data, format, 
                                            flags);
@@ -689,11 +689,11 @@
         };
     };
     if (alloc_certs)
-        stat_free(certs);
+        caml_stat_free(certs);
     net_gnutls_error_check(code);
     CAMLreturn(array);
 #else
-    invalid_argument("gnutls_x509_crl_list_import");
+    caml_invalid_argument("gnutls_x509_crl_list_import");
 #endif
 }
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/nettls-gnutls/gnutls.descr ocamlnet-4.1.9.patched/src/nettls-gnutls/gnutls.descr
--- src/nettls-gnutls/gnutls.descr	2021-03-24 16:20:15
+++ src/nettls-gnutls/gnutls.descr	2026-05-29 06:31:44
@@ -560,7 +560,7 @@
       ~options: [
         `Pre("if (data_size__c < 0 || \
                   data_size__c > caml_ba_byte_size(Caml_ba_array_val(data))) \
-                      invalid_argument(\"gnutls_record_send\");"
+                      caml_invalid_argument(\"gnutls_record_send\");"
             )
       ]
       "error_code/uint gnutls_record_send \
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/nettls-gnutls/nettle.c ocamlnet-4.1.9.patched/src/nettls-gnutls/nettle.c
--- src/nettls-gnutls/nettle.c	2021-03-24 16:20:15
+++ src/nettls-gnutls/nettle.c	2026-05-29 06:31:44
@@ -39,12 +39,12 @@
 static net_nettle_cipher_ctx_t
          net_nettle_create_cipher_ctx(net_nettle_cipher_t cipher) {
     void *p;
-    p = stat_alloc(cipher->context_size);
+    p = caml_stat_alloc(cipher->context_size);
     return p;
 }
 
 static void net_nettle_free(void *ctx) {
-    stat_free(ctx);
+    caml_stat_free(ctx);
 }
 
 static void net_nettle_destroy_cipher(net_nettle_cipher_t cipher) {
@@ -57,7 +57,7 @@
                                        const uint8_t *key) {
 #ifdef HAVE_NETTLE_SET_KEY_WITH_TWO_ARGS
     if (length != cipher->key_size)
-        failwith("net_nettl_set_encrypt_key: key has wrong size");
+        caml_failwith("net_nettl_set_encrypt_key: key has wrong size");
     cipher->set_encrypt_key(ctx, key);
 #else
     cipher->set_encrypt_key(ctx, length, key);
@@ -71,7 +71,7 @@
                                        const uint8_t *key) {
 #ifdef HAVE_NETTLE_SET_KEY_WITH_TWO_ARGS
     if (length != cipher->key_size)
-        failwith("net_nettl_set_decrypt_key: key has wrong size");
+        caml_failwith("net_nettl_set_decrypt_key: key has wrong size");
     cipher->set_decrypt_key(ctx, key);
 #else
     cipher->set_decrypt_key(ctx, length, key);
@@ -292,7 +292,7 @@
 
 static net_nettle_gcm_aes_ctx_t net_nettle_gcm_aes_init(void) {
 #ifdef HAVE_NETTLE_GCM_H
-    return stat_alloc(sizeof(struct gcm_aes_ctx));
+    return caml_stat_alloc(sizeof(struct gcm_aes_ctx));
 #else
     return NULL;
 #endif
@@ -321,7 +321,7 @@
 static net_nettle_hash_ctx_t
          net_nettle_create_hash_ctx(net_nettle_hash_t hash) {
     void *p;
-    p = stat_alloc(hash->context_size);
+    p = caml_stat_alloc(hash->context_size);
     return p;
 }
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/nettls-gnutls/nettls_gnutls.ml ocamlnet-4.1.9.patched/src/nettls-gnutls/nettls_gnutls.ml
--- src/nettls-gnutls/nettls_gnutls.ml	2021-03-24 16:20:15
+++ src/nettls-gnutls/nettls_gnutls.ml	2026-05-29 06:31:44
@@ -4,7 +4,7 @@
 
 module StrMap = Map.Make(String)
 module StrSet = Set.Make(String)
-module OID = struct type t = Netoid.t let compare = Pervasives.compare end
+module OID = struct type t = Netoid.t let compare = compare end
 module OIDMap = Map.Make(OID)
 
 module type GNUTLS_PROVIDER =
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/nettls-gnutls/reconfigure ocamlnet-4.1.9.patched/src/nettls-gnutls/reconfigure
--- src/nettls-gnutls/reconfigure	2021-03-24 16:20:15
+++ src/nettls-gnutls/reconfigure	2026-05-29 06:31:44
@@ -216,10 +216,10 @@
 
 rm -f config_checks.sh
 echo "$ ocaml -I ../../tools gnutls.descr" >>$log
-ocaml -I ../../tools gnutls.descr || exit 1
+ocaml -I +str -I ../../tools gnutls.descr || exit 1
 
 echo "$ ocaml -I ../../tools nettle.descr" >>$log
-ocaml -I ../../tools nettle.descr || exit 1
+ocaml -I +str -I ../../tools nettle.descr || exit 1
 
 init_checks
 . ./config_checks.sh
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/rpc/rpc_client.ml ocamlnet-4.1.9.patched/src/rpc/rpc_client.ml
--- src/rpc/rpc_client.ml	2021-03-24 16:20:15
+++ src/rpc/rpc_client.ml	2026-05-29 06:31:44
@@ -49,7 +49,7 @@
 
 module SessionUint4 = struct
   type t = uint4
-  let compare = (Pervasives.compare : uint4 -> uint4 -> int)
+  let compare = (compare : uint4 -> uint4 -> int)
 end
 
 module SessionMap =
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/rpc/rpc_proxy.ml ocamlnet-4.1.9.patched/src/rpc/rpc_proxy.ml
--- src/rpc/rpc_proxy.ml	2021-03-24 16:20:15
+++ src/rpc/rpc_proxy.ml	2026-05-29 06:31:44
@@ -414,7 +414,7 @@
       | `Up up -> up.serial
 
   let compare mc1 mc2 =
-    Pervasives.compare mc1.id mc2.id
+    compare mc1.id mc2.id
 
   let pending_calls mc =
     mc.pending_calls
@@ -1037,7 +1037,7 @@
 	  (* Sort the services by total load first: *)
 	  Array.sort 
 	    (fun j1 j2 ->
-	       Pervasives.compare 
+               compare
 		 mset.total_load.(j1)
 		 mset.total_load.(j2)
 	    )
